/***************************************************************************
                          animation.h  -  description
                             -------------------
    begin                : Mit Aug 21 2002
    copyright            : (C) 2002 by Thomas Friedrichsmeier
    email                : tfry@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef ANIMATION_H
#define ANIMATION_H

#include "tpbase.h"
#include "soundhandle.h"
#include "cdp.h"
#include <qcanvas.h>
#include <qstring.h>

/**This class is used to store all the information for a (generalized) animation. To be used with AnimatedSprite. Contains sound-support and a function to read in the information from a qdom-element
  *@author Thomas Friedrichsmeier
  */

class QDomElement;

class Animation : public TPBase  {
public: 
	Animation(const QDomElement *description, const int options = 0, const int soundoptions = 0, QString suffix_a = "", QString suffix_b = "");
	~Animation();
	bool multiFrame () { return (frames > 1); }
	int framePeriod () { return (frame_period); }
private:
	void readAnimation (const QDomElement *descr, QString & sufa, QString & sufb, const int opts, const int soundopts);

	friend class AnimatedSprite;

	SoundHandle sound;
	int repetitions;
	bool continuous;
	bool oscillating;
	QCanvasPixmapArray * seq[2];
	int frames;
	int frame_period;
};

#endif
